

#include <EEPROM.h>
#include <Sodaq_DS3231.h>
#include <Wire.h>
#include <DHT.h> 

#define pinDHT_1 12
#define pinDHT_2 13
#define pinDHT_3 4
#define pinDHT_4 2
#define typDHT22 DHT22   // DHT 22 

//pin na která jsou připojeny senzory pohybu
#define Pin_pohyb_1 5
#define Pin_pohyb_2 6
#define Pin_pohyb_3 7
#define Pin_pohyb_4 8

// inicializace DHT senzoru s nastaveným typem senzoru
DHT DHT_1(pinDHT_1, typDHT22);
DHT DHT_2(pinDHT_2, typDHT22);
DHT DHT_3(pinDHT_3, typDHT22);
DHT DHT_4(pinDHT_4, typDHT22);

//pin na která jsou připojena LED světla
int led1= 11;   //PWM
int led2= 10;   //PWM
int led3= 9;  //PWM
int led4= 3 ; //PWM
byte LED ; //pomocná proměnná

int tep1; int vlh1;int tep2; int vlh2;int tep3; int vlh3;int tep4; int vlh4;

String zprava_1="" ;String zprava0=""; String zprava1="" ; String zprava2="" ;
byte stav_1=0;byte stav_2=0;byte stav_3=0;byte stav_4=0;
boolean konec = false;
String s1_0=""; String s1_1=""; String s2_0=""; String s2_1="";String s3_0=""; String s3_1="";String s4_0=""; String s4_1="";
unsigned int cas1=0; unsigned int cas2=0; unsigned int cas3=0; unsigned int cas4=0;
 int c1 = 0; unsigned int c2 = 0;unsigned int c3 = 0;unsigned int c4 = 0;  //odpočítávání
 int cas_svetla_1;unsigned int cas_svetla_2;unsigned int cas_svetla_3;unsigned int cas_svetla_4;//určuje délku svícení LED 1-3
 boolean povolit_1=true; boolean povolit_2=true; boolean povolit_3=true; boolean povolit_4=true;//povoluje-zakazuje fungování čidel(LED světla)

byte pohyb_1=0; byte pohyb_2=0; byte pohyb_3=0; byte pohyb_4=0;
boolean vypis_cidla = false;  //povoluje/zakazuje výpis na displej

int senzor_svetla_1 = A0;  //pin pro senzor světla-1
int senzor_svetla_2 = A1;  //pin pro senzor světla-2
int senzor_svetla_3 = A2;  //pin pro senzor světla-3
int senzor_svetla_4 = A3;  //pin pro senzor světla-4

//proměnná pro aktuální hodnotu okolního světla na čidlech
unsigned int lux1 = 0; //hladina okolního světla(čidlo-1)
unsigned int lux2 = 0; //hladina okolního světla(čidlo-2)
unsigned int lux3 = 0; //hladina okolního světla(čidlo-3)
unsigned int lux4 = 0; //hladina okolního světla(čidlo-4)

//proměnná pro nastavení hodnoty okolního světla pro zap/vyp LED
unsigned int hladina_svetla_1_ON;  // hladina okolního světla pro zapnutí světla(0-65535)
unsigned int hladina_svetla_1_OFF; // hladina okolního světla pro vypnutí světla
unsigned int hladina_svetla_2_ON;
unsigned int hladina_svetla_2_OFF;
unsigned int hladina_svetla_3_ON;
unsigned int hladina_svetla_3_OFF;
unsigned int hladina_svetla_4_ON;
unsigned int hladina_svetla_4_OFF;


// proměnná pro nastavení hladiny PWM signálu pro řízení svitu LED pásky
int LED_svit1=255; int LED_svit1_den=255; int LED_svit1_noc=15; 
int LED_svit2=255; int LED_svit2_den=255; int LED_svit2_noc=15;
int LED_svit3=255; int LED_svit3_den=255; int LED_svit3_noc=15;
int LED_svit4=255; int LED_svit4_den=255; int LED_svit4_noc=15;

  float pomoc=0; unsigned int pomoc_0=0;unsigned int pomoc_1=0;unsigned int pomoc_2=0;//pro průběžné ukládání
  unsigned long stopky_1 = 0;unsigned long stopky_2 = 0;unsigned long stopky_3 = 0;unsigned long stopky_4 = 0;//odečítání času LED

 //char weekDay[][8] = {"PONDELI", "UTERY", "STREDA", "CTVRTEK", "PATEK", "SOBOTA", "NEDELE"};
 
      //proměnná pro režim den-noc
          int hod_den1; int min_den1;
          int hod_den2; int min_den2;
          int hod_den3; int min_den3;
          int hod_den4; int min_den4;
          
          int hod_noc1; int min_noc1;
          int hod_noc2; int min_noc2;
          int hod_noc3; int min_noc3;
          int hod_noc4; int min_noc4;

void setup() {
  // put your setup code here, to run once:
  pinMode(led1,OUTPUT);pinMode(led2,OUTPUT);pinMode(led3,OUTPUT);pinMode(led4,OUTPUT);
  digitalWrite(led1, LOW); digitalWrite(led2, LOW); digitalWrite(led3, LOW); digitalWrite(led4, LOW);
   
  pinMode(Pin_pohyb_1, INPUT); digitalWrite(Pin_pohyb_1, LOW);
  pinMode(Pin_pohyb_2, INPUT); digitalWrite(Pin_pohyb_2, LOW);
  pinMode(Pin_pohyb_3, INPUT); digitalWrite(Pin_pohyb_3, LOW);
  pinMode(Pin_pohyb_4, INPUT); digitalWrite(Pin_pohyb_4, LOW);
  pinMode(pinDHT_1, INPUT);pinMode(pinDHT_2, INPUT);pinMode(pinDHT_3, INPUT);pinMode(pinDHT_4, INPUT);

 Serial.begin(9600);  
 Wire.begin(); 
 Serial.setTimeout(100);

 DHT_1.begin();// zapnutí komunikace s teploměrem DHT
 DHT_2.begin();
 DHT_3.begin();
 DHT_4.begin();

  //nastavení objektů displeje do základního stavu
   Serial.print("page Hlavni");SerialFFF(); Serial.print("Hlavni.t10.txt=\"" "\"");  SerialFFF();  delay(1000);
     }

    void loop() {
 
    nacti_zpravu();
    
         } 


    void nacti_zpravu(){
        String zprava_1="";
   while(Serial.available()>0) {
     zprava_1 = Serial.readString();
   
     delay(50);
              if (zprava_1=="n1") {cteni_A();Serial.print(F("page Senzor"));SerialFFF();setting();}
         else if (zprava_1=="n2") {cteni_A();vypis_cidla = true;Serial.print(F("page A"));SerialFFF();}                      
         else if (zprava_1=="n3") {cteni_A();Serial.print(F("page F"));SerialFFF();}
         else if (zprava_1=="n4") {cteni_A(); Serial.print(F("page Svetlo"));SerialFFF();/*menu_svetlo();*/}
         else if (zprava_1=="n5") {cteni_A();Serial.print(F("page Minutka"));SerialFFF();/*minutka();*/}
         else if (zprava_1=="n6") {cteni_A();Serial.print(F("page Info"));SerialFFF(); }
         else if (zprava_1=="home"){cteni_A();vypis_cidla = false;Serial.print(F("page Hlavni"));SerialFFF();konec=false;}
         else{zprava_1="";}
            } }
   

  void vypni_Svetla(){  //vypne LED světla a vynuluje odpočítávání na disleji
        digitalWrite(led1, LOW); Serial.print(F("A.n2.val=0")); SerialFFF();Serial.print(F("A.b0.picc=74"));SerialFFF();
        digitalWrite(led2, LOW); Serial.print(F("A.n7.val=0")); SerialFFF();Serial.print(F("A.b1.picc=74"));SerialFFF();
        digitalWrite(led3, LOW); Serial.print(F("A.n12.val=0")); SerialFFF();Serial.print(F("A.b2.picc=74"));SerialFFF();
        digitalWrite(led4, LOW); Serial.print(F("A.n17.val=0"));SerialFFF();Serial.print(F("A.b3.picc=74"));SerialFFF();
              }

   void Senzory(){
       lux1 = map(analogRead(senzor_svetla_1), 0, 1023, 0, 200); 
       lux2 = map(analogRead(senzor_svetla_2), 0, 1023, 0, 200);
       lux3 = map(analogRead(senzor_svetla_3), 0, 1023, 0, 200);
       lux4 = map(analogRead(senzor_svetla_4), 0, 1023, 0, 200);
       pohyb_1 = digitalRead(Pin_pohyb_1); if(pohyb_1==HIGH){c1=0;stopky_1 = millis()/1000;}
       pohyb_2 = digitalRead(Pin_pohyb_2); if(pohyb_2==HIGH){c2=0;stopky_2 = millis()/1000;}
       pohyb_3 = digitalRead(Pin_pohyb_3); if(pohyb_3==HIGH){c3=0;stopky_3 = millis()/1000;}
       pohyb_4 = digitalRead(Pin_pohyb_4); if(pohyb_4==HIGH){c4=0;stopky_4 = millis()/1000;}
               }

    void Senzory_vypis() {
          //senzor světla
          Serial.print(F("A.n0.val=")); Serial.print(lux1);SerialFFF(); 
          Serial.print(F("A.n5.val=")); Serial.print(lux2);SerialFFF();
          Serial.print(F("A.n10.val="));Serial.print(lux3);SerialFFF();
          Serial.println(F("A.n15.val="));Serial.print(lux4);SerialFFF();
          //senzor pohybu
          Serial.print(F("A.n1.val=")); Serial.print(pohyb_1);SerialFFF();
          Serial.print(F("A.n6.val=")); Serial.print(pohyb_2);SerialFFF();
          Serial.print(F("A.n11.val="));Serial.print(pohyb_3);SerialFFF();
          Serial.print(F("A.n16.val="));Serial.print(pohyb_4);SerialFFF();
                  }

     void Hodiny_vypis() {
         DateTime now = rtc.now(); 
           //datum
         Serial.print(F("Hlavni.n23.val="));Serial.print(now.date());SerialFFF();
         Serial.print(F("Hlavni.n24.val="));Serial.print(now.month());SerialFFF();
         Serial.print(F("Hlavni.n25.val="));Serial.print(now.year());SerialFFF();
           //hodiny
         Serial.print(F("Hlavni.n20.val="));Serial.print(now.hour());SerialFFF();
         Serial.print(F("Hlavni.n21.val="));Serial.print(now.minute());SerialFFF();
         Serial.print(F("Hlavni.n22.val="));Serial.print(now.second());SerialFFF();
         Serial.print(F("Hlavni.day.val="));Serial.print(now.dayOfWeek());SerialFFF();
                    }

  
                    
     void SerialFFF() {
    Serial.write(0xff);
    Serial.write(0xff);
    Serial.write(0xff);
    delay(10); 
       }

     //PAGE A
    void cteni_A(){
  zprava1 = "t10.txt=\"";
  zprava1 += zprava_1;
  zprava1 += "\"";
  Serial.print(zprava1);
  SerialFFF(); }
  

  
 

 
   
 
